function part1(action,number)
%PART1 Internally used by FINDEMO.

% Copyright (c) 1996-98 by Rafal Weron.
% Written by: J. Glowinski, R. Weron.
 
global FIGURE COLOR LENGTH OLD OLD2 LINE POSITION L R V MIN MAX NUMBER GRAPHICS START;
 
if nargin==0
  action='init';
  set(FIGURE(5),'visible','off');
  LENGTH=3;
  OLD=[];
  OLD2=[10 10 490 510 1];
end
 
if strcmp(action,'init')
  FIGURE=switch(FIGURE,1);
  pos=get(FIGURE(1),'position');
  set(FIGURE(1),'resize','off',...
                'position',[pos(1) pos(2) 580 30*LENGTH+180],...
                'color',COLOR,...
                'menubar','none',...
                'numbertitle','off',...
                'name','Profit/loss graph');
  clf;
  drawnow;

  m=size(OLD,1);
  LINE=zeros(LENGTH,1);
  POSITION=zeros(LENGTH,6);
  for i=1:m,
    y=30*(LENGTH+1-i);
    LINE(i)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','checkbox',...
                      'position',[40 y 20 20]);
    set(LINE(i),'value',OLD(i,7));
    POSITION(i,1)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
                            'position',[80 y 40 20],...
                            'string',num2str(OLD(i,1)));
    POSITION(i,2)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','popupmenu',...
                            'position',[140 y 90 20],...
                            'string','LONG|SHORT');
    set(POSITION(i,2),'value',OLD(i,2));
    POSITION(i,3)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
                            'position',[250 y 40 20],...
                            'string',num2str(OLD(i,3))); 
    POSITION(i,4)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','popupmenu',...
                            'position',[310 y 90 20],...
                            'string','CALL|PUT|FUTURES');
    set(POSITION(i,4),'value',OLD(i,4));
    uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
              'position',[420 y 20 20],...
              'string','@'); 
    POSITION(i,5)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
                            'position',[440 y 40 20],...
                            'string',num2str(OLD(i,5)));
    POSITION(i,6)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
                            'position',[500 y 40 20],...
                            'string',num2str(OLD(i,6)));
  end
  for i=(m+1):LENGTH,
    y=30*(LENGTH+1-i);
    LINE(i)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','checkbox',...
                      'position',[40 y 20 20]);  
    POSITION(i,1)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
                            'position',[80 y 40 20],...
                            'string','1');
    POSITION(i,2)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','popupmenu',...
                            'position',[140 y 90 20],...
                            'string','LONG|SHORT'); 
    POSITION(i,3)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
                            'position',[250 y 40 20],...
                            'string','500'); 
    POSITION(i,4)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','popupmenu',...
                            'position',[310 y 90 20],...
                            'string','CALL|PUT|FUTURES'); 
    uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
              'position',[420 y 20 20],...
              'string','@'); 
    POSITION(i,5)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
                            'position',[440 y 40 20],...
                            'string','0');
    POSITION(i,6)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
                            'position',[500 y 40 20],...
                            'string','10');
  end
  y=30*LENGTH;

  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[40 y+130 120 20],...
            'string','PARAMETERS');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[50 y+90 50 20],...
            'string','r=');
  R=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
              'position',[110 y+90 40 20],...
              'string',num2str(OLD2(1)));
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[50 y+70 50 20],...
            'string','v=');
  V=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
              'position',[110 y+70 40 20],...
              'string',num2str(OLD2(2)));
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[50 y+50 50 20],...
            'string','lines=');
  L=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
              'position',[110 y+50 40 20],...
              'string',num2str(LENGTH),...
              'callback','part1(''length'')');

  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[180 y+130 120 20],...
            'string','RANGE');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[190 y+90 50 20],...
            'string','min=');
  MIN=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
                'position',[250 y+90 40 20],...
                'string',num2str(OLD2(3)));
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[190 y+70 50 20],...
            'string','max=');
  MAX=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
                'position',[250 y+70 40 20],...
                'string',num2str(OLD2(4)));

  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[320 y+130 120 20],...
            'string','GRAPHICS');
  for i=1:2,
    GRAPHICS(i)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','radiobutton',...
                          'position',[330 y+110-20*i 100 20],...
                          'callback',['part1(''graphics'',' int2str(i) ')']);
  end
  set(GRAPHICS(1),'string','2D plot');
  set(GRAPHICS(2),'string','3D plot');
  NUMBER=OLD2(5);
  set(GRAPHICS(NUMBER),'value',1);
  
  START=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','pushbutton',...
                  'position',[470 y+130 70 20],...
                  'callback','part1(''start'')');
  if NUMBER==1
    set(START,'string','PLOT');
  else
    set(START,'string','MESH');
  end
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','pushbutton',...
            'position',[470 y+90 70 20],...
            'string','HELP',...
            'callback','part1(''help'')');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','pushbutton',...
            'position',[470 y+50 70 20],...
            'string','EXIT',...
            'callback','part1(''exit'')');

elseif strcmp(action,'graphics')
  set(GRAPHICS(NUMBER),'value',0);
  set(GRAPHICS(number),'value',1);
  if NUMBER~=number
    if number==1
      set(START,'string','PLOT');
    else
      set(START,'string','MESH');
    end
    NUMBER=number;
  end

elseif strcmp(action,'length')
  l=str2num(get(L,'string'));
  screen=get(0,'screensize');
  if 1<=l & l<=floor((screen(4)-210)/30)
    m=min(LENGTH,l);
    OLD=zeros(m,7);
    for i=1:m,
      OLD(i,1)=str2num(get(POSITION(i,1),'string'));
      OLD(i,2)=get(POSITION(i,2),'value');
      OLD(i,3)=str2num(get(POSITION(i,3),'string'));
      OLD(i,4)=get(POSITION(i,4),'value');
      OLD(i,5)=str2num(get(POSITION(i,5),'string'));
      OLD(i,6)=str2num(get(POSITION(i,6),'string'));
      OLD(i,7)=get(LINE(i),'value');      
    end
    OLD2(1)=str2num(get(R,'string'));
    OLD2(2)=str2num(get(V,'string'));
    OLD2(3)=str2num(get(MIN,'string'));
    OLD2(4)=str2num(get(MAX,'string'));
    OLD2(5)=NUMBER;
    LENGTH=l;
    part1('init');
  else
    disp('Sorry, to many lines');
  end

elseif strcmp(action,'start')
  row=1;
  for i=1:LENGTH,
    if get(LINE(i),'value')
      p(row,1)=str2num(get(POSITION(i,1),'string'));
      if get(POSITION(i,2),'value')==1
        p(row,2)=-1;
      else
        p(row,2)=1;
      end
      p(row,3)=str2num(get(POSITION(i,3),'string'));
      if get(POSITION(i,4),'value')==1
        p(row,4)=1;
      elseif get(POSITION(i,4),'value')==2
        p(row,4)=-1;
      else
        p(row,4)=0;
      end
      p(row,5)=str2num(get(POSITION(i,5),'string'));
      p(row,6)=str2num(get(POSITION(i,6),'string'));
      row=row+1;
    end
  end
  if row>1
    FIGURE=switch(FIGURE,2);
    set(FIGURE(2),'numbertitle','off',...
                  'name','Position');
    clf;
    minp=str2num(get(MIN,'string'));
    maxp=str2num(get(MAX,'string'));
    if NUMBER==1
      position(p,minp,maxp);
    else
      r=str2num(get(R,'string'));
      v=str2num(get(V,'string'));
      pos3(p,r,v,minp,maxp);
    end
  end

elseif strcmp(action,'help')
  page1=...
    ['r, v                                                  '
     '  annual interest rate/volatility (in percent);       '
     'lines                                                 '
     '  number of lines used to define the position;        '
     'Below in columns:                                     '
     '  - selection of active lines;                        '
     '  - number of contracts;                              '
     '  - LONG/SHORT position;                              '
     '  - strike price;                                     '
     '  - type of contract: CALL, PUT, FUTURES;             '
     '  - premium (needed only for options);                '
     '  - time to maturity (in days);                       '
     'min, max                                              '
     '  range of prices on the plot;                        '
     '2D plot, 3D plot                                      '
     '  2D/3D graphics;                                     '
     'PLOT (MESH)                                           '
     '  2D payout profile at maturity (3D payout profile,   '
     '  before option maturity theoretical - Black model -  '
     '  prices are used to evaluate the position);          '
     'HELP                                                  '
     '  this help window;                                   '
     'EXIT                                                  '
     '  return to FINDEMO;                                  '];

  page2=...
    ['r, v                                                  '
     '  roczna stopa procentowa/zmiennosc (w procentach);   '
     'lines                                                 '
     '  liczba linii edycyjnych;                            '
     'Ponizej w kolumnach:                                  '
     '  - zaznaczenie aktywnych linii edycyjnych;           '
     '  - liczba kontraktow;                                '
     '  - dluga/krotka pozycja;                             '
     '  - cena wykonania kontraktu;                         '
     '  - typ kontraktu: opcja kupna lub sprzedazy, futures;'
     '  - premia (potrzebna tylko dla opcji);               '
     '  - czas do wygasniecia, podany w dniach;             '
     'min, max                                              '
     '  zakres cen instrumentu podstawowego na wykresie;    '
     '2D plot, 3D plot                                      '
     '  rodzaj grafiki (2D, 3D);                            '
     'PLOT (MESH)                                           '
     '  2D wykres pozycji w terminie wygasniecia (3D wykres '
     '  pozycji, przed terminem wygasniecia opcji jest      '
     '  rysowana teoretyczna wartosc pozycji w mod. Blacka);'
     'HELP                                                  '
     '  pomoc;                                              '
     'EXIT                                                  '
     '  powrot do FINDEMO;                                  '];

  buttonStr=['English';
             'Polski ';
             '       '];
  helpfn('Profit/loss graph',buttonStr,page1,page2);
  pos=get(gcf,'position');
  set(gcf,'name','Help',...
    'position',[pos(1) pos(2) 460 370],...
    'resize','off',...
    'menubar','none');


elseif strcmp(action,'exit')
  list=get(0,'children');
  for i=1:length(list),
    if list(i)~=FIGURE(5)
      close(list(i));
    end
  end
  set(FIGURE(5),'visible','on');
  clear global LENGTH OLD OLD2 LINE POSITION L R V MIN MAX NUMBER GRAPHICS START;
end

