function part3(action,argument)
%PART3 Internally used by FINDEMO.

% Copyright (c) 1996-98 by Rafal Weron.
% Written by: J. Glowinski, R. Weron.
 
global FIGURE COLOR NUMBER MODE S0 T R D Up Down N V N1 N2 PAYOUT PRICE TREE START REBUILD;

if nargin==0
  action='init';
end

if strcmp(action,'init')
  set(FIGURE(5),'visible','off');

  FIGURE=switch(FIGURE,1);
  pos=get(FIGURE(1),'position');
  set(FIGURE(1),...
    'resize','off',...
    'position',[pos(1) pos(2) 440 290],...
    'color',COLOR,...
    'menubar','none',...
    'numbertitle','off',...
    'name','General discrete model'...
  );
  clf;

  uicontrol('backgroundcolor',[0.753 0.753 0.753],...
    'style','text',...
    'position',[40 200 130 20],...
    'string','OPTION TYPE'...
  );
  for i=1:2,
    MODE(i)=uicontrol('backgroundcolor',[0.753 0.753 0.753],...
              'style','radiobutton',...
              'position',[50 180-20*i 110 20],...
              'callback',['part3(''mode'',' int2str(i) ')']...
            );
  end 
  set(MODE(1),'string','European');
  set(MODE(2),'string','American');
  NUMBER=1;
  set(MODE(1),'value',1);

  uicontrol('backgroundcolor',[0.753 0.753 0.753],...
    'style','text',...
    'position',[190 200 210 20],...
    'string','PARAMETERS'...
  );
  uicontrol('backgroundcolor',[0.753 0.753 0.753],...
    'style','text',...
    'position',[200 160 30 20],...
    'string','So=');
  S0=uicontrol('backgroundcolor',[0.753 0.753 0.753],...
    'style','edit',...
    'position',[240 160 50 20],...
    'string','100',...
    'callback','part3(''clear'',''s'');');

  uicontrol('backgroundcolor',[0.753 0.753 0.753],...
    'style','text',...
    'position',[200 140 30 20],...
    'string','T=');
  T=uicontrol('backgroundcolor',[0.753 0.753 0.753],...
    'style','edit',...
    'position',[240 140 50 20],...
    'string','365',...
    'callback','part3(''clear'',''t'');');

  uicontrol('backgroundcolor',[0.753 0.753 0.753],...
    'style','text',...
    'position',[200 120 30 20],...
    'string','r=');
  R=uicontrol('backgroundcolor',[0.753 0.753 0.753],...
    'style','edit',...
    'position',[240 120 50 20],...
    'string','10',...
    'callback','part3(''clear'',''r'');');

  uicontrol('backgroundcolor',[0.753 0.753 0.753],...
    'style','text',...
    'position',[200 100 30 20],...
    'string','D=');
  D=uicontrol('backgroundcolor',[0.753 0.753 0.753],...
    'style','edit',...
    'position',[240 100 50 20],...
    'string','5',...
    'callback','part3(''clear'',''d'');');

  uicontrol('backgroundcolor',[0.753 0.753 0.753],...
    'style','text',...
    'position',[295 160 40 20],...
    'string','u=');
  Up=uicontrol('backgroundcolor',[0.753 0.753 0.753],...
    'style','edit',...
    'position',[340 160 50 20],...
    'string','1.1',...
    'callback','part3(''clear'',''u'')');

  uicontrol('backgroundcolor',[0.753 0.753 0.753],...
    'style','text',...
    'position',[295 140 40 20],...
    'string','d=');
  Down=uicontrol('backgroundcolor',[0.753 0.753 0.753],...
    'style','edit',...
    'position',[340 140 50 20],...
    'string','0.9',...
    'callback','part3(''clear'',''u'')');

  uicontrol('backgroundcolor',[0.753 0.753 0.753],...
    'style','text',...
    'position',[295 120 40 20],...
    'string','n=');
  N=uicontrol('backgroundcolor',[0.753 0.753 0.753],...
    'style','edit',...
    'position',[340 120 50 20],...
    'string','5',...
    'callback','part3(''clear'',''n'')');

  uicontrol('backgroundcolor',[0.753 0.753 0.753],...
    'style','text',...
    'position',[40 70 180 20],...
    'string','PAYOUT FORMULA');
  PAYOUT=uicontrol('backgroundcolor',[0.753 0.753 0.753],...
    'style','edit',...
    'position',[50 30 160 20],...
    'string','max(100-S,0)',...
    'callback','part3(''clear'',''p'');');

  uicontrol('backgroundcolor',[0.753 0.753 0.753],...
    'style','text',...  
    'position',[250 70 150 20],...
    'string','OPTION PRICE:');
  PRICE=uicontrol('backgroundcolor',[0.753 0.753 0.753],...
    'style','text',...
    'position',[260 30 130 20],...
    'string','  ');

  START=uicontrol('backgroundcolor',[0.753 0.753 0.753],...
    'style','pushbutton',...
    'position',[40 240 80 20],...
    'string','RUN',...
    'callback','part3(''start'')');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],...
    'style','pushbutton',...
    'position',[140 240 80 20],...
    'string','HELP',...
    'callback','part3(''help'')');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],...
    'style','pushbutton',...
    'position',[240 240 80 20],...
    'string','EXIT',...
    'callback','part3(''exit'')');


elseif strcmp(action,'clear')
  if argument=='n'                
    n=str2num(get(N,'string'));   
    if n<0 set(N,'string','5'); end 
    set(START,'string','RUN');    
  end 
  set(PRICE,'string','  '); 
  REBUILD=1;

elseif strcmp(action,'mode')
  set(MODE(NUMBER),'value',0);
  set(MODE(argument),'value',1);
  if NUMBER~=argument
    list=get(0,'children');
    for i=1:length(list),
      if list(i)==FIGURE(2) | list(i)==FIGURE(3)
        close(list(i));
      end 
    end 
    NUMBER=argument;
    part3('clear','m'); 
  end 

elseif strcmp(action,'start')
  s0=str2num(get(S0,'string'));
  t=str2num(get(T,'string'));
  r=str2num(get(R,'string'));
  d=str2num(get(D,'string'));

  REBUILD=0;
  n=str2num(get(N,'string'));
  upstr=get(Up,'string');
  downstr=get(Down,'string');
  up=str2num(upstr);
  down=str2num(downstr);
  if n<=5	
    FIGURE=switch(FIGURE,2);
    pos=get(FIGURE(2),'position');
    set(FIGURE(2),...
      'resize','off',...
      'position',[pos(1) pos(2) 580 420],...
      'color',COLOR,...				
      'numbertitle','off',...
      'name','Tree 1');
    clf;    
    set(axes,'position',[0 0 1 0.85],'visible','off');    
    axis([-0.5 n+0.5 -n-0.5 n+0.5]);    
    titlestr='STOCK PRICES';
    paramstr=['(T=',   num2str(t),...
              ', n=',  num2str(n),...
              ', r=',  num2str(r),...
              ', d=',  num2str(d),     ')'];
    pos=get(gcf,'position');
    text2((pos(3)-10*length(titlestr))/2,400,titlestr);    
    text2((pos(3)-7*length(paramstr))/2,380,paramstr);
    h=line([0,n],[0,-n]);
    set(h,'color',[1,0,0]);
    for i=1:n-1,
      h=line([i,n],[i,-n+2*i]);
      set(h,'color',[1,0,0]);
    end 
    h=line([0,n],[0,n]);
    set(h,'color',[1,0,0]);
    for i=1:n-1,
      h=line([i,n],[-i,n-2*i]);
      set(h,'color',[1,0,0]);
    end 
    for i=0:n,
      for j=0:i,
        x=i-0.2;
        y=i-2*j;

        figurepos=get(gcf,'position');
        axespos=get(gca,'position');
        axispos=axis;

        ax=axespos(3)*figurepos(3)/(axispos(2)-axispos(1));
        bx=figurepos(3)*axespos(1)-ax*axispos(1);
        xpix=ax*x+bx;

        ay=axespos(4)*figurepos(4)/(axispos(4)-axispos(3));
        by=figurepos(4)*axespos(2)-ay*axispos(3);
        ypix=ay*y+by;

        TREE((i+1)*i/2+j+1)=uicontrol(...
          'style','edit',...
          'position',[xpix ypix-10 50 20],...
          'foregroundcolor',[1 1 1],...
          'backgroundcolor',[0 0 1]);
      end 
    end 
  end 
  if upstr(1)=='+' & downstr(1)=='-'       
    s(1)=s0;
    if n<=5 set(TREE(1),'string',num2str(s(1),5)); end 
    for i=1:n,
      first=(1+i)*i/2+1;
      for l=first:(first+i-1),
        s(l)=s(l-i)+up;
        if n<=5 set(TREE(l),'string',num2str(s(l),5)); end 
      end 
      s(first+i)=s(first-1)+down;
      if n<=5 set(TREE(first+i),'string',num2str(s(first+i),5)); end 
    end 
  else		
    s(1)=s0;
    if n<=5 set(TREE(1),'string',num2str(s(1),5));end 
    for i=1:n,
      first=(1+i)*i/2+1;
      for l=first:(first+i-1),
        s(l)=up*s(l-i);
        if n<=5 set(TREE(l),'string',num2str(s(l),5)); end 
      end 
      s(first+i)=down*s(first-1);
      if n<=5 set(TREE(first+i),'string',num2str(s(first+i),5));end 
    end 
  end 
  if n<=5 
    uicontrol('style','pushbutton',...
      'position',[20 373 60 30],...
      'string','NEXT',...
      'callback','part3(''next'')');
  else 
    part3('next',s); 
  end 

elseif strcmp(action,'next')
  if REBUILD==0
    n=str2num(get(N,'string'));
    t=str2num(get(T,'string'));
    r=str2num(get(R,'string'));
    d=str2num(get(D,'string'));
    if nargin==1 % nacisnieto NEXT
      for i=0:n,
        first=(1+i)*i/2+1;
        for l=first:(first+i),
          s(l)=str2num(get(TREE(l),'string'));
        end 
      end 
    else s=argument; 
    end 
    evalstr=['c(l)=' get(PAYOUT,'string') ';'];
    first=(1+(n+1))*(n+1)/2-n;
    for l=first:first+n,
      S=s(l);
      eval(evalstr);
    end 
    qr=exp(0.01*(r-d)*t/365/n); 
    cr=exp(-0.01*r*t/365/n);    
    for i=n:-1:1,
      first=(1+i)*i/2-i+1;
      for l=first:(first+i-1),
        q=(qr*s(l)-s(l+i+1))/(s(l+i)-s(l+i+1)); 
        c(l)=(q*c(l+i)+(1-q)*c(l+i+1))*cr;      
        if NUMBER==2 	
          S=s(l);	
          pomoc=c(l);   
          eval(evalstr);
          c(l)=max(c(l),pomoc);
          clear pomoc;
        end 
      end 
    end 
    if nargin==1	
      FIGURE=switch(FIGURE,3);
      pos=get(FIGURE(3),'position');
      set(FIGURE(3),'resize','off',...
                    'position',[pos(1) pos(2) 580 420],...
                    'color',COLOR,...
                    'numbertitle','off',...
                    'name','Tree 2');
      clf; 
      paramstr=['(T=',  num2str(t),...
                ', n=', num2str(n),...
                ', r=', num2str(r),...
                ', d=', num2str(d),...
                ')'];
      tree('OPTION PRICES',paramstr,n,c,-1);
      figure(FIGURE(3)); 
      for i=n:-1:1,
        first=(1+i)*i/2-i+1;
        for l=first:(first+i-1),
          if s(l+i)~=s(l+i+1)
            q=(qr*s(l)-s(l+i+1))/(s(l+i)-s(l+i+1));
            q=round(1000*q)/1000;
            x=i;
            y=i-2*(l-first);
            h=text(x-0.65,y-0.1,num2str(q));
            set(h,'fontsize',8);
            h=text(x-0.55,y-1.1,num2str(1-q));
            set(h,'fontsize',8);
          end 
        end
      end
    end
    set(PRICE,'string',num2str(c(1)) );
  else
    disp('You must rebuild the stock prices tree');
  end

elseif strcmp(action,'help')
  page1=...
    ['RUN                                                   '
     '  plot underlying and option prices trees;            '
     '  for trees with more then 5 steps to maturity        '
     '  only the option price is given;                     '
     'HELP                                                  '
     '  this help window;                                   '
     'EXIT                                                  '
     '  return to FINDEMO;                                  '
     'OPTION TYPE                                           '
     '  select European or American exercise;               '
     'PARAMETERS                                            '
     '  So - underlying instrument price at time 0;         '
     '  T - time to option maturity (in days);              '
     '  r - annual interest rate (in percent);              '
     '  D - annual dividend rate (in percent);              '
     '  u,d - up, down jump; both can be given in           '
     '    an additive (Su=S+u, e.g. u=+10, d=-20) or        '
     '    a multiplicative (Su=S*u, e.g. u=1.1, d=0.9) way; '
     '  n - number of price jumps to maturity;              '
     'PAYOUT FORMULA                                        '
     '  user defined function (dependend on S - underlying  '
     '  price at maturity), e.g. for the standard           '
     '  european call with strike 100: max(S-100,0);        '
     'OPTION PRICE                                          '
     '  binomial price of the specified option;             '];

  page2=...
    ['RUN                                                   '
     '  wykres drzewka cen instrumentu podstawowego;        '
     '  dla drzewek z wiecej niz 5 krokami do terminu       '
     '  wygasniecia jest podawana tylko cena opcji;         '
     'HELP                                                  '
     '  pomoc;                                              '
     'EXIT                                                  '
     '  powrot do FINDEMO;                                  '
     'OPTION TYPE                                           '
     '  rodzaj opcji: europejska lub amerykanska;           '
     'PARAMETERS                                            '
     '  So - cena instrumentu podstawowego w chwili 0;      '
     '  T - termin wygasniecia opcji (w dniach);            '
     '  r - roczna stopa procentowa (w procentach);         '
     '  D - roczna stopa dywidendy (w procentach);          '
     '  u,d - skok w gore, dol; dopuszczalne sa 2 definicje:'
     '    addytywna (Su=S+u, e.g. u=+10, d=-20) oraz        '
     '    multiplikatywna (Su=S*u, e.g. u=1.1, d=0.9);      '
     '  n - liczba krokow do terminu wygasniecia;           '
     'PAYOUT FORMULA                                        '
     '  funkcja wyplaty podawana przez uzytkownika,         '
     '  np. dla standardowej europejskiej opcji kupna       '
     '  z cena wykonania 100 wynosi: max(S-100,0);          '
     'OPTION PRICE                                          '
     '  cena opcji obliczona w modelu dwumianowym;          '];

  buttonStr=['English';
             'Polski ';
             '       '];
  helpfn('General discrete model',buttonStr,page1,page2);
  pos=get(gcf,'position');
  set(gcf,'name','Help',...
    'position',[pos(1) pos(2) 450 400],...
    'resize','off',...
    'menubar','none');

elseif strcmp(action,'exit')
  list=get(0,'children');
  for i=1:length(list),
    if list(i)~=FIGURE(5)
      close(list(i));
    end
  end
  set(FIGURE(5),'visible','on');  
  clear global NUMBER MODE S0 T R D Up Down N V N1 N2 PAYOUT PRICE TREE START REBUILD;
end
