function part4(action)
%PART4 Internally used by FINDEMO.

% Copyright (c) 1996-98 by Rafal Weron.
% Written by: M. Grot, R. Weron.
 
global FIGURE COLOR TYPE TYPE1 PAYOUT S0 T R U D N K H X TREE TREE2 START REBUILD;

if nargin==0
   action='init';
end
 
if strcmp(action,'init')
  set(FIGURE(5),'visible','off');

  FIGURE=switch(FIGURE,1);
  pos=get(FIGURE(1),'position');
  set(FIGURE(1),'resize','off',...
                'position',[pos(1) pos(2) 360 310],...
                'color',COLOR,...
                'menubar','none',...
                'numbertitle','off',...
                'name','Exotic options (tree)');
  clf;

  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','text',...
             'position',[40 210 130 20],...
             'string','PARAMETERS');
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','text',...
             'position',[50 170 30 20],...
             'string','So=');
  S0=...
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','edit',...
             'position',[90 170 70 20],...
             'string','100',...
             'callback','part4(''type'')');
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','text',...
             'position',[50 150 30 20],...
             'string','u=');
  U=...
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','edit',...
             'position',[90 150 70 20],...
             'string','1.1');
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','text',...
             'position',[50 130 30 20],...
             'string','d=');
  D=...
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','edit',...
             'position',[90 130 70 20],...
             'string','0.9');
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','text',...
             'position',[50 110 30 20],...
             'string','n=');
  N=...
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','edit',...
             'position',[90 110 70 20],...
             'string','5');
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','text',...
             'position',[50 90 30 20],...
             'string','T=');
  T=...
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','edit',...
             'position',[90 90 70 20],...
             'string','365');
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','text',...
             'position',[50 70 30 20],...
             'string','r=');
  R=...
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','edit',...
             'position',[90 70 70 20],...
             'string','10');
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','text',...
             'position',[50 50 30 20],...
             'string','K=');
  K=...
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','edit',...
             'position',[90 50 70 20],...
             'string','100',...
             'visible','off',...
             'callback','part4(''type'')');
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','text',...
             'position',[50 30 30 20],...
             'string','H=');
  H=...
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','edit',...
             'position',[90 30 70 20],...
             'string','150',...
             'visible','off',...
             'callback','part4(''type'')');
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','text',...
             'position',[190 210 130 20],...
             'string','OPTION TYPE');
  TYPE=...
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','popupmenu',...
             'position',[190 170 130 20],...
             'string','LOOKBACK|BARRIER|AVERAGE RATE',...
             'value',1,...
             'callback','part4(''type'')');
  TYPE1=...
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','popup',...
             'position',[190 130 130 20],...
             'string','CALL | PUT',...
             'value',1,...
             'callback','part4(''type'')');
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','text',...
             'position',[180 100 150 15],...
             'string','PAYOUT FORMULA');
  PAYOUT=...
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','text',...
             'position',[180 70 150 20],...
             'string','Sn - min(Si; i=0:n)');
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','text',...
             'position',[180 40 150 15],...
             'string','OPTION PRICE');
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','text',...
             'position',[200 10 30 20],...
             'string','X=');
  X=...
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','text',...
             'position',[240 10 70 20]);
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','pushbutton',...
             'position',[40 260 70 20],...
             'string','RUN',...
             'callback','part4(''run'')');
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','pushbutton',...
             'position',[220 260 70 20],...
             'string','EXIT',...
             'callback','part4(''exit'')');
  uicontrol( 'backgroundcolor',[0.753 0.753 0.753],'style','pushbutton',...
             'position',[130 260 70 20],...
             'string','HELP',...
             'callback','part4(''help'')');

elseif strcmp(action,'type')
 
  type=get(TYPE,'value');
  type1=get(TYPE1,'value');

  if type==1
    set(K,'visible','off');
    set(H,'visible','off');
    if type1==1   set(PAYOUT,'string','Sn - min(Si; i=0:n)');
    else          set(PAYOUT,'string','max(Si; i=0:n) - Sn'); 
    end

  elseif type==2
    set(H,'visible','on');
    set(K,'visible','on');
    s0s =get(S0,'string');    
    s0  =str2num(s0s);
    hs  =get(H,'string');    
    h   =str2num(hs);
    if type1==1  
        if h>s0
          set(PAYOUT,'string','max(0,Sn-K)*(Si<H)');
        else
          set(PAYOUT,'string','max(0,Sn-K)*(Si>H)');
        end
    else
        if h>s0 
          set(PAYOUT,'string','max(0,K-Sn)*(Si<H)'); 
        else
          set(PAYOUT,'string','max(0,K-Sn)*(Si>H)'); 
        end
    end

  else
    set(H,'visible','off');
    set(K,'visible','on');
    if type1==1   set(PAYOUT,'string','max(sum(Si)/(n+1)-K,0)');
    else          set(PAYOUT,'string','max(K-sum(Si)/(n+1),0)'); 
    end
  end

elseif strcmp(action,'rebuild')
  REBUILD=1;

elseif strcmp(action,'run')
  s0=str2num(get(S0,'string'));
  t=str2num(get(T,'string'));
  r=str2num(get(R,'string'));

    REBUILD=0;
    n=str2num(get(N,'string'));
    if n<=5
      ustr=get(U,'string');
      dstr=get(D,'string');
      u=str2num(ustr);
      d=str2num(dstr);
      FIGURE=switch(FIGURE,2);
      pos=get(FIGURE(2),'position');
      set(FIGURE(2),'resize','off',...
                    'position',[pos(1) pos(2) 580 420],...
                    'color',COLOR,...
                    'numbertitle','off',...
                    'name','Tree 1');
      clf;    
      set(axes,'position',[0 0 1 0.85],'visible','off');    
      axis([-0.5 n+0.5 -n-0.5 n+0.5]);    
      titlestr='STOCK PRICES';
      paramstr=['(T=' num2str(t) ', n=' num2str(n) ', r=' num2str(r) ')'];
      pos=get(gcf,'position');
      text2((pos(3)-10*length(titlestr))/2,400,titlestr);    
      text2((pos(3)-7*length(paramstr))/2,380,paramstr);
      h=line([0 n],[0 -n]);
      set(h,'color',[1 0 0]);
      for i=1:n-1,
        h=line([i n],[i -n+2*i]);
        set(h,'color',[1 0 0]);
      end
      h=line([0 n],[0 n]);
      set(h,'color',[1 0 0]);
      for i=1:n-1,
        h=line([i n],[-i n-2*i]);
        set(h,'color',[1 0 0]);
      end
      for i=0:n,
        for j=0:i,
          x=i-0.2;
          y=i-2*j;

          figurepos=get(gcf,'position');
          axespos=get(gca,'position');
          axispos=axis;

          ax=axespos(3)*figurepos(3)/(axispos(2)-axispos(1));
          bx=figurepos(3)*axespos(1)-ax*axispos(1);
          xpix=ax*x+bx;

          ay=axespos(4)*figurepos(4)/(axispos(4)-axispos(3));
          by=figurepos(4)*axespos(2)-ay*axispos(3);
          ypix=ay*y+by;

          TREE((i+1)*i/2+j+1)=uicontrol('style','edit',...
                                        'position',[xpix ypix-10 50 20],...
                                        'foregroundcolor',[1 1 1],...
                                        'backgroundcolor',[0 0 1]);
        end
      end
      if ustr(1)=='+' & dstr(1)=='-'
        s(1)=s0;
        set(TREE(1),'string',num2str(s(1),5));
        for i=1:n,
          first=(1+i)*i/2+1;
          for l=first:(first+i-1),
            s(l)=s(l-i)+u;
            set(TREE(l),'string',num2str(s(l),5));
          end
          s(first+i)=s(first-1)+d;
          set(TREE(first+i),'string',num2str(s(first+i),5));
        end      
      else
        s(1)=s0;
        set(TREE(1),'string',num2str(s(1),5));
        for i=1:n,
          first=(1+i)*i/2+1;
          for l=first:(first+i-1),
            s(l)=u*s(l-i);
            set(TREE(l),'string',num2str(s(l),5));
          end
          s(first+i)=d*s(first-1);
          set(TREE(first+i),'string',num2str(s(first+i),5));
        end
      end
      uicontrol('style','pushbutton',...
                'position',[20 373 60 30],...
                'string','NEXT',...
                'callback','part4(''next'')');
    else
      disp('Tree works only for n<=5');
    end

elseif strcmp(action,'next')
  if REBUILD==0
    n=str2num(get(N,'string'));
    t=str2num(get(T,'string'));
    r=str2num(get(R,'string'));
    type=get(TYPE,'value');
    type1=get(TYPE1,'value');
 

    for i=0:n,                  
      first=(1+i)*i/2+1;
      for l=first:(first+i),
        s(l)=str2num(get(TREE(l),'string'));
      end
    end
    
    rr=exp(0.01*r*t/365/n);
    
    for i=n:-1:1,               
      first=(1+i)*i/2-i+1;
      for l=first:(first+i-1),
        q(l)=(rr*s(l)-s(l+i+1))/(s(l+i)-s(l+i+1));
      end
    end
       
    M =traject(n);                
    MM=zeros(2^n,2);            

    if type==1                  
      if type1==1               
      for i=1:2^n
        MM(i,1)=s(M(i,n+1))-min(s(M(i,:)));
        MM(i,2)=M(i,n+1);       % lookback call 
      end 
      else                      % lookback put 
      for i=1:2^n
        MM(i,1)=max(s(M(i,:)))-s(M(i,n+1));
        MM(i,2)=M(i,n+1);
      end 
      end 
     
    elseif type==3              % arithmetic call
      k=str2num(get(K,'string'));
      if type1==1
      for i=1:2^n
        MM(i,1)=max(sum(s(M(i,:)))/(n+1)-k,0);
        MM(i,2)=M(i,n+1);
      end 
      else                      % arithmetic put
      for i=1:2^n
        MM(i,1)=max(k-sum(s(M(i,:)))/(n+1),0);
        MM(i,2)=M(i,n+1);
      end 
      end 
    
    else                        % barrier call
      k=str2num(get(K,'string'));
      h=str2num(get(H,'string'));
      if type1==1
        if h>s(1)      
          for i=1:2^n
            MM(i,1)=max(s(M(i,n+1))-k,0)*(sum(s(M(i,:))>=h)==0);
            MM(i,2)=M(i,n+1);
          end
        else
          for i=1:2^n
            MM(i,1)=max(s(M(i,n+1))-k,0)*(sum(s(M(i,:))<=h)==0);
            MM(i,2)=M(i,n+1);
          end
        end 
      else                      % barrier put
        if h>s(1)
          for i=1:2^n
            MM(i,1)=max(k-s(M(i,n+1)),0)*(sum(s(M(i,:))>=h)==0);
            MM(i,2)=M(i,n+1);
          end
	else
          for i=1:2^n
            MM(i,1)=max(k-s(M(i,n+1)),0)*(sum(s(M(i,:))<=h)==0);
            MM(i,2)=M(i,n+1);
          end
	end 
      end
    end 
           
      FIGURE=switch(FIGURE,3);
      pos=get(FIGURE(3),'position');
      set(FIGURE(3),'resize','off',...
                    'position',[pos(1) pos(2) 580 420],...
                    'color',COLOR,...
                    'numbertitle','off',...
                    'name','Tree 2');
      clf;    
      set(axes,'position',[0 0 1 0.85],'visible','off');    
      axis([-0.5 n+0.5 -n-0.5 n+0.5]);    
      titlestr='OPTION PRICES';
      paramstr=['(T=' num2str(t) ', n=' num2str(n) ', r=' num2str(r) ')'];
      pos=get(gcf,'position');
      text2((pos(3)-10*length(titlestr))/2,400,titlestr);    
      text2((pos(3)-7*length(paramstr))/2,380,paramstr);
      h=line([0 n],[0 -n]);
      set(h,'color',[1 0 0]);
      for i=1:n-1,
        h=line([i n],[i -n+2*i]);
        set(h,'color',[1 0 0]);
      end
      h=line([0 n],[0 n]);
      set(h,'color',[1 0 0]);
      for i=1:n-1,
        h=line([i n],[-i n-2*i]);
        set(h,'color',[1 0 0]);
      end
      for i=0:n,
        for j=0:i,
          x=i-0.2;
          y=i-2*j;

          figurepos=get(gcf,'position');
          axespos=get(gca,'position');
          axispos=axis;

          ax=axespos(3)*figurepos(3)/(axispos(2)-axispos(1));
          bx=figurepos(3)*axespos(1)-ax*axispos(1);
          xpix=ax*x+bx;

          ay=axespos(4)*figurepos(4)/(axispos(4)-axispos(3));
          by=figurepos(4)*axespos(2)-ay*axispos(3);
          ypix=ay*y+by;

          TREE2((i+1)*i/2+j+1)=uicontrol('style','popup',...
                                        'position',[xpix ypix-10 50 20],...
                                        'value',1,...
                                        'foregroundcolor',[1 1 1],...
                                        'backgroundcolor',[0 0 1]);
        end
      end
    
    for k=n:-1:1
        first=(k+2)*(k+1)/2-k;
        for i=first:first+k
          ss='';
          M=MM(MM(:,2)==i,1);
          for j=1:size(M)
               if ss=='' ss=num2str(M(j));
               else ss=[ss,'|',num2str(M(j))];
               end
          end
          set(TREE2(i),'string',ss);
        end
        l=1;
        NN=zeros(2^(k-1),2);
        for j=1:2:2^k-1
          NN(l,1)=(MM(j,1)*q(MM(j,2)-k)+MM(j+1,1)*(1-q(MM(j,2)-k)))/rr;
          NN(l,2)=MM(j,2)-k;
          l=l+1;
        end
        MM=NN;
    end

    set(TREE2(1),'string',num2str(MM(1,1)));
    set(X,'string',num2str(MM(1,1)));

    for i=n:-1:1,
      first=(1+i)*i/2-i+1;
      for l=first:(first+i-1),
        if s(l+i)~=s(l+i+1)
          q=(rr*s(l)-s(l+i+1))/(s(l+i)-s(l+i+1));
          q=round(1000*q)/1000;
          x=i;
          y=i-2*(l-first);
          h=text(x-0.65,y-0.1,num2str(q));
          set(h,'fontsize',8);
          h=text(x-0.55,y-1.1,num2str(1-q));
          set(h,'fontsize',8);
        end
      end
    end


  else
    disp('You must rebuild the stock prices tree');
  end

elseif strcmp(action,'help')
  page1=...
    ['RUN                                                   '
     '  plot underlying and option prices trees;            '
     '  works only for trees with no more then 5 steps      '
     '  to maturity;                                        '
     'HELP                                                  '
     '  this help window;                                   '
     'EXIT                                                  '
     '  return to FINDEMO;                                  '
     'PARAMETERS                                            '
     '  So - underlying instrument price at time 0;         '
     '  u,d - up, down jump; both can be given in           '
     '    an additive (Su=S+u, e.g. u=+10, d=-20) or        '
     '    a multiplicative (Su=S*u, e.g. u=1.1, d=0.9) way; '
     '  n - number of price jumps to maturity;              '
     '  T - time to option maturity (in days);              '
     '  r - annual interest rate (in percent);              '
     '  K - strike price (for asian and barrier options);   '
     '  H - barrier (only for barrier options);             '
     'OPTION TYPE                                           '
     '  select asian (average rate), barrier or lookback    '
     '  options; all options can be either calls or puts;   '
     'PAYOUT FORMULA                                        '
     '  payout formula of the selected option;              '
     'OPTION PRICE                                          '
     '  binomial price of the selected option;              '];

  page2=...
    ['RUN                                                   '
     '  rozpoczecie obliczen (wycena opcji);                '
     '  jesli wielkosc drzewka n>5, to obliczenia nie       '
     '  zostana przeprowadzone;                             '
     'HELP                                                  '
     '  pomoc;                                              '
     'EXIT                                                  '
     '  powrot do FINDEMO;                                  '
     'PARAMETERS                                            '
     '  So - cena instrumentu podstawowego w chwili 0;      '
     '  u,d - skok w gore, dol; dopuszczalne sa 2 definicje:'
     '    addytywna (Su=S+u, e.g. u=+10, d=-20) oraz        '
     '    multiplikatywna (Su=S*u, e.g. u=1.1, d=0.9);      '
     '  n - liczba krokow do terminu wygasniecia;           '
     '  T - termin wygasniecia opcji (w dniach);            '
     '  r - roczna stopa procentowa (w procentach);         '
     '  K - cena wykonania (opcje azjatyckie i barierowe);  '
     '  H - bariera (tylko dla opcji barierowych);          '
     'OPTION TYPE                                           '
     '  klasa opcji egzotycznej (lookback, barierowej,      '
     '  azjatyckiej) oraz sposob wykonania opcji;           '
     'PAYOUT FORMULA                                        '
     '  funkcja wyplaty;                                    '
     'OPTION PRICE                                          '
     '  obliczona cena opcji egzotycznej;                   '];

  buttonStr=['English';
             'Polski ';
             '       '];
  helpfn('Exotic options (tree)',buttonStr,page1,page2);
  pos=get(gcf,'position');
  set(gcf,'name','Help',...
    'position',[pos(1) pos(2) 450 400],...
    'resize','off',...
    'menubar','none');

elseif strcmp(action,'exit')
  list=get(0,'children');
  for i=1:length(list),
    if list(i)~=FIGURE(5)
      close(list(i));
    end
  end
  set(FIGURE(5),'visible','on');
  clear global TYPE TYPE1 PAYOUT S0 T R U D N K H X TREE TREE2 START REBUILD;

end
