function part6(action, number)
%PART6 Internally used by FINDEMO.

% Copyright (c) 1996-98 by Rafal Weron.
% Written by: M. Orzeszyna, R. Weron, L. Wojakowski.
 
global FIGURE COLOR MODEL OPTION NUMBER RUN INPUT OUTPUT POS...
  TEXT X K  T R V  EXPERIM_RES DELTA ...
  QW Q QDAY BSVAL draw_quantiles is_Brown;

if nargin==0
  action='init';
end;

if strcmp(action,'init')
  set(FIGURE(5),'visible','off'); 
  RUN=0;
  FIGURE=switch(FIGURE,1);
  pos=get(FIGURE(1),'position');
  set(FIGURE(1),'resize','off',...
 		'position',[pos(1) pos(2) 580 390],...
		'color',COLOR,...
		'menubar','none',...
		'numbertitle','off',...
		'name','Exotic options (Monte Carlo)');
  clf;

  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
  	    'position',[20 300 120 20],...
	    'string','TYPE');

  % OPTINO - Call/Put selection
  for i=1:2,
    OPTION(i)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','radiobutton',...
    'position',[20 295-25*i 120 25],...
    'callback',['part6(''option'',' int2str(i) ')']);
  end;

  set(OPTION(1),'string','Call option');
  set(OPTION(2),'string','Put option');
  NUMBER(1)=1;
  set(OPTION(1),'value',1);

  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
  'position',[170 300 300 20],...
  'string','OPTIONS');
	
  is_Brown=0;	

  MODEL(1)=uicontrol('backgroundcolor',[0.753 0.753 0.753],	'style','popupmenu',...
		     'position',[170 275 300 20],...
		     'string',...
  'PLAIN VANILLA|CORRIDOR KNOCK-OUT|LOOKBACK #1: S-min(S(t))|LOOKBACK #2: S-lambda*min(S(t))|MODIFIED LOOKBACK: max(0, max(S(t))-K)|AVERAGE RATE: max(0, A-K)|AVERAGE STRIKE: max(0, S-A)',...
  		     'visible','on',...
		     'callback',['part6(''model'',get(gco,''value''))']);

  MODEL(2)=uicontrol('backgroundcolor',[0.753 0.753 0.753],	'style','popupmenu',...
  		     'position',[170 275 300 20],...
		     'string',...
  'PLAIN VANILLA|CORRIDOR KNOCK-OUT|LOOKBACK #1: max(S(t))-S|LOOKBACK #2: max(0,lambda*max(S(t))-S)|MODIFIED LOOKBACK: max(0, K-min(S(t)))|AVERAGE RATE: max(0, K-A)|AVERAGE STRIKE: max(0, A-S)',...
  		     'visible','off',...
		     'callback',['part6(''model'',get(gco,''value''))']);

  TEXT(1)=uicontrol('backgroundcolor',[0.753 0.753 0.753],	'style','text',...
  		    'string','lambda:',...
		    'position',[170 250 100 20],...
		    'visible','off');	

  % MODEL(3) lambda window (lookback #2)
  MODEL(3)=uicontrol('backgroundcolor',[0.753 0.753 0.753],	'style','edit',...
  		     'string','.5',...
		     'position',[280 250 40 20],...
		     'callback','part6(''lambda'',1)',...
		     'backgroundcolor',[0.753 0.753 0.753],...
		     'foregroundcolor',[0 0 0],...
		     'visible','off');

  % MODEL(4) arithmetic/geometric asian option
  MODEL(4)=uicontrol('backgroundcolor',[0.753 0.753 0.753],	'style','popupmenu',...
  		     'string','ARITHMETIC|GEOMETRIC',...
		     'position',[280 250 190 20],...
		     'backgroundcolor',[0.753 0.753 0.753],...
		     'foregroundcolor',[0 0 0],...
		     'visible','off');
  TEXT(3)=uicontrol('backgroundcolor',[0.753 0.753 0.753],	'style','text',...
  		    'string','up:',...
		    'position',[170 250 50 20],...
		    'visible','off');	

  % MODEL(5-6) 5-up, 6-down barrier for corridor options
  MODEL(5)=uicontrol('backgroundcolor',[0.753 0.753 0.753],	'style','edit',...
  		     'string','110',...
		     'position',[230 250 40 20],...
		     'backgroundcolor',[0.753 0.753 0.753],...
		     'foregroundcolor',[0 0 0],...
		     'callback','part6(''lambda'',4)',...
		     'visible','off');
  TEXT(4)=uicontrol('backgroundcolor',[0.753 0.753 0.753],	'style','text',...
  		    'string','down:',...
		    'position',[290 250 50 20],...
		    'visible','off');	
	
  MODEL(6)=uicontrol('backgroundcolor',[0.753 0.753 0.753],	'style','edit',...
  		     'string','90',...
		     'position',[350 250 40 20],...
		     'backgroundcolor',[0.753 0.753 0.753],...
		     'foregroundcolor',[0 0 0],...
		     'callback','part6(''lambda'',4)',...
		     'visible','off');

  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[20 210 120 20],...
            'string','PARAMETERS');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
  	    'position',[20 170 70 20],...
            'string','So=');
  X=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
  	      'position',[100 170 55 20],...
  	      'string','100',...
	      'backgroundcolor',[0.753 0.753 0.753],...
	      'foregroundcolor',[0 0 0],...
              'callback','part6(''lambda'',3)');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[20 150 70 20],...
            'string','K=');
  K=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
              'position',[100 150 55 20],...
              'string','100',...
	      'backgroundcolor',[0.753 0.753 0.753],...
	      'foregroundcolor',[0 0 0],...
              'callback','part6(''lambda'',3)');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[20 130 70 20],...
            'string','T=');
  T=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
              'position',[100 130 55 20],...
              'string','10',...
              'callback','part6(''size'')',...
	      'backgroundcolor',[0.753 0.753 0.753],...
	      'foregroundcolor',[0 0 0]);

  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[20 110 70 20],...
            'string','r=');
  R=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
              'position',[100 110 25 20],...
              'string','3',...
	      'backgroundcolor',[0.753 0.753 0.753],...
	      'foregroundcolor',[0 0 0],...
              'callback','part6(''lambda'',7)');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[125 110 30 20],...
	    'backgroundcolor',[0.753 0.753 0.753],...
	    'foregroundcolor',[0 0 0],...
            'string','%');

  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[20 90 70 20],...
            'string','v=');
  V=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
              'position',[100 90 25 20],...
              'string','9',...
	      'backgroundcolor',[0.753 0.753 0.753],...
	      'foregroundcolor',[0 0 0],...
              'callback','part6(''lambda'',7)');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[125 90 30 20],...
	    'backgroundcolor',[0.753 0.753 0.753],...
	    'foregroundcolor',[0 0 0],...
            'string','%');

  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[20 70 70 20],...
            'string','quantity');
  Q=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
              'position',[100 70 55 20],...
              'string','100',...
              'backgroundcolor',[0.753 0.753 0.753],...
	      'foregroundcolor',[0 0 0],...
              'callback','part6(''lambda'',5)');

  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[20 50 70 20],...
            'string','per day');
  QDAY=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
              'position',[100 50 55 20],...
              'string','12',...
              'backgroundcolor',[0.753 0.753 0.753],...
	      'foregroundcolor',[0 0 0],...
              'callback','part6(''lambda'',6)');

  draw_quantiles=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','checkbox',...
            'position',[170 50 90 20],...
            'string','quantiles',...
	    'value',1);

  QW=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
              'position',[270 50 160 20],...
              'string','.3 .7',...
	      'backgroundcolor',[0.753 0.753 0.753],...
	      'foregroundcolor',[0 0 0],...
	      'callback','part6(''lambda'',2)');
		
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','popupmenu',...
              'position',[270 25 160 20],...
              'string','.3 .7|.1 .9|.1 .3 .7 .9|.1 .2 .3 .4 .5 .6 .7 .8 .9',...
	      'callback','part6(''pop'')');

  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
  	    'position',[170 210 390 20],...
            'string','OPTION PRICES');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','pushbutton',...
            'position',[390 178 50 20],...
            'string','>',...
            'callback','part6(''right'')');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','pushbutton',...
            'position',[335 178 50 20],...
            'string','<',...
            'callback','part6(''left'')');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','pushbutton',...
            'position',[445 178 50 20],...
            'string','END',...
            'callback','part6(''end'')');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','pushbutton',...
            'position',[280 178 50 20],...
            'string','HOME',...
            'callback','part6(''home'')');

  uicontrol('backgroundcolor',[0.753 0.753 0.753],	'style','text',...
  	    'position',[170 150 90 20],...
	    'string','Maturity');

  POS=0;
  for i=1:5,
    x=210+60*i;
    INPUT(1,i)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
                         'position',[x 150 50 20],...
                         'string',num2str(i-1));
  end;  

  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
  	    'position',[170 115 90 30],...
            'string','Simulation value');
  BSVAL=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            	  'position',[170 80 90 30],...
		  'visible','off',...
            	  'string','Black-Scholes value');

  % OUTPUT displays option prices
  for i=1:5,
    x=210+60*i;
    OUTPUT(1,i)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
                          'position',[x 115 50 30]);
    OUTPUT(2,i)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
    			  'visible','off',...
                          'position',[x 80 50 30]);
  end;

  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','pushbutton',...
            'position',[20 340 70 20],...
            'string','RUN',...
            'callback','part6(''run'')');

  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','pushbutton',...
            'position',[110 340 70 20],...
            'string','HELP',...
            'callback','part6(''help'')');

  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','pushbutton',...
            'position',[200 340 70 20],...
            'string','EXIT',...
            'callback','part6(''exit'')');

elseif strcmp(action,'option')
  set(OPTION(NUMBER(1)),'value',0);
  set(OPTION(number),'value',1);

  if NUMBER(1)~=number
    if number==1
      set(MODEL(1),'visible','on');
      set(MODEL(2),'visible','off');

      tmp=get(MODEL(1),'value');
      if tmp==2 
	if strcmp(get(TEXT(1),'visible'),'on')
	  set(TEXT(1),'visible','off');
	  set(MODEL(3),'visible','off');
	end;
	if strcmp(get(TEXT(2),'visible'),'on')
	  set(MODEL(4),'visible','off');
	  set(TEXT(2),'visible','off');
	end;
	if strcmp(get(TEXT(3),'visible'),'off')
	  set(TEXT(3),'visible','on');
	  set(TEXT(4),'visible','on');
	  set(MODEL(5),'visible','on');
	  set(MODEL(6),'visible','on');			
	end;
      elseif tmp==4
        if strcmp(get(TEXT(1),'visible'),'off')
	  set(TEXT(1),'visible','on');
	  set(MODEL(3),'visible','on');
	end;
	if strcmp(get(MODEL(4),'visible'),'on')
	  set(MODEL(4),'visible','off');
	  set(TEXT(2),'visible','off');
	end;
	if strcmp(get(TEXT(3),'visible'),'on')
	  set(TEXT(3),'visible','off');
	  set(TEXT(4),'visible','off');
	  set(MODEL(5),'visible','off');
	  set(MODEL(6),'visible','off');			
	end;
      elseif (tmp==7 | tmp==6)
        if strcmp(get(TEXT(1),'visible'),'on')
	  set(TEXT(1),'visible','off');
	  set(MODEL(3),'visible','off');
	end;
	if strcmp(get(MODEL(4),'visible'),'off')
	  set(MODEL(4),'visible','on');
	  set(TEXT(2),'visible','on');
	end;
	if strcmp(get(TEXT(3),'visible'),'on')
	  set(TEXT(3),'visible','off');
	  set(TEXT(4),'visible','off');
	  set(MODEL(5),'visible','off');
	  set(MODEL(6),'visible','off');			
	end;
    else
      if strcmp(get(TEXT(1),'visible'),'on')
        set(TEXT(1),'visible','off');
	set(MODEL(3),'visible','off');
      end;
      if strcmp(get(MODEL(4),'visible'),'on')
        set(MODEL(4),'visible','off');
	set(TEXT(2),'visible','off');
      end;
      if strcmp(get(TEXT(3),'visible'),'on')
        set(TEXT(3),'visible','off');
	set(TEXT(4),'visible','off');
	set(MODEL(5),'visible','off');
	set(MODEL(6),'visible','off');			
      end;
    end;
    else
      set(MODEL(1),'visible','off');
      set(MODEL(2),'visible','on')
      tmp=get(MODEL(2),'value');
      if tmp==2
        if strcmp(get(TEXT(1),'visible'),'on')
	  set(TEXT(1),'visible','off');
	  set(MODEL(3),'visible','off');
	end;
	if strcmp(get(TEXT(2),'visible'),'on')
	  set(MODEL(4),'visible','off');
	  set(TEXT(2),'visible','off');
	end;
	if strcmp(get(TEXT(3),'visible'),'off')
	  set(TEXT(3),'visible','on');
	  set(TEXT(4),'visible','on');
	  set(MODEL(5),'visible','on');
	  set(MODEL(6),'visible','on');			
	end;
      elseif tmp==4
        if strcmp(get(TEXT(1),'visible'),'off')
	  set(TEXT(1),'visible','on');
	  set(MODEL(3),'visible','on');
	end;
	if strcmp(get(MODEL(4),'visible'),'on')
	  set(MODEL(4),'visible','off');
	  set(TEXT(2),'visible','off');
	end;
	if strcmp(get(TEXT(3),'visible'),'on')
	  set(TEXT(3),'visible','off');
	  set(TEXT(4),'visible','off');
	  set(MODEL(5),'visible','off');
	  set(MODEL(6),'visible','off');			
	end;
      elseif (tmp==7 | tmp==6)
        if strcmp(get(TEXT(1),'visible'),'on')
	  set(TEXT(1),'visible','off');
	  set(MODEL(3),'visible','off');
	end;
	if strcmp(get(MODEL(4),'visible'),'off')
          set(MODEL(4),'visible','on');
	  set(TEXT(2),'visible','on');
	end;
	if strcmp(get(TEXT(3),'visible'),'on')
	  set(TEXT(3),'visible','off');
	  set(TEXT(4),'visible','off');
	  set(MODEL(5),'visible','off');
	  set(MODEL(6),'visible','off');			
	end;
      else
        if strcmp(get(TEXT(1),'visible'),'on')
	  set(TEXT(1),'visible','off');
	  set(MODEL(3),'visible','off');
	end;
	if strcmp(get(MODEL(4),'visible'),'on')
	  set(MODEL(4),'visible','off');
	  set(TEXT(2),'visible','off');
	end;
	if strcmp(get(TEXT(3),'visible'),'on')
	  set(TEXT(3),'visible','off');
	  set(TEXT(4),'visible','off');
	  set(MODEL(5),'visible','off');
	  set(MODEL(6),'visible','off');			
	end;
      end;
    end
    NUMBER(1)=number;
  end

elseif strcmp(action,'model')
  if number==2
    if strcmp(get(TEXT(1),'visible'),'on')
      set(TEXT(1),'visible','off');
      set(MODEL(3),'visible','off');
    end;
    if strcmp(get(TEXT(2),'visible'),'on')
      set(MODEL(4),'visible','off');
      set(TEXT(2),'visible','off');
    end;
    if strcmp(get(TEXT(3),'visible'),'off')
      set(TEXT(3),'visible','on');
      set(TEXT(4),'visible','on');
      set(MODEL(5),'visible','on');
      set(MODEL(6),'visible','on');			
    end;
  elseif number==4
    if strcmp(get(TEXT(1),'visible'),'off')
      set(TEXT(1),'visible','on');
      set(MODEL(3),'visible','on');
    end;
    if strcmp(get(MODEL(4),'visible'),'on')
      set(MODEL(4),'visible','off');
      set(TEXT(2),'visible','off');
    end;
    if strcmp(get(TEXT(3),'visible'),'on')
      set(TEXT(3),'visible','off');
      set(TEXT(4),'visible','off');
      set(MODEL(5),'visible','off');
      set(MODEL(6),'visible','off');			
    end;
  elseif (number==6 | number==7)
    if strcmp(get(TEXT(1),'visible'),'on')
      set(TEXT(1),'visible','off');
      set(MODEL(3),'visible','off');
    end;
    if strcmp(get(MODEL(4),'visible'),'off')
      set(MODEL(4),'visible','on');
      set(TEXT(2),'visible','on');
    end;
    if strcmp(get(TEXT(3),'visible'),'on')
      set(TEXT(3),'visible','off');
      set(TEXT(4),'visible','off');
      set(MODEL(5),'visible','off');
      set(MODEL(6),'visible','off');			
    end;
  else
    if strcmp(get(TEXT(1),'visible'),'on')
      set(TEXT(1),'visible','off');
      set(MODEL(3),'visible','off');
    end;
    if strcmp(get(MODEL(4),'visible'),'on')
      set(MODEL(4),'visible','off');
      set(TEXT(2),'visible','off');
    end;
    if strcmp(get(TEXT(3),'visible'),'on')
      set(TEXT(3),'visible','off');
      set(TEXT(4),'visible','off');
      set(MODEL(5),'visible','off');
      set(MODEL(6),'visible','off');			
    end;
  end;
  
elseif strcmp(action,'size')
  RUN=0;

  t=str2num(get(T,'string'));
  if (isempty(t))
    t = 0;
  end;
  if (fix(t)-t)~=0
    t = 0;
  end;
  if t<4
    set(T,'string','4');
  end;
  
  n=str2num(get(T,'string'));

  POS=0;
  m=min(5,n+1);
  for i=1:m,
    set(INPUT(1,i),'visible','on','string',num2str(i-1));
    set(OUTPUT(1,i),'visible','on','string','');
	if is_Brown==1
	        set(OUTPUT(2,i),'string','','visible','on');
	end;

  end

  for i=m+1:5,
    set(INPUT(:,i),'visible','off');
    set(OUTPUT(:,i),'visible','off');
  end


elseif strcmp(action,'right')
  n=str2num(get(T,'string'));
  if n>4 & POS+4<n
    POS=POS+1;
    for i=1:5,
      j=POS+i;
 	set(INPUT(1,i),'string',num2str(j-1));

    end
    if RUN
      for i=1:5,
        j=POS+i;
        set(OUTPUT(1,i),'string',change('01',(EXPERIM_RES(j)) ) );
	if is_Brown==1
	        set(OUTPUT(2,i),'string',change('01',(DELTA(j))));
	end;

      end
    end
  end

elseif strcmp(action,'left')
  n=str2num(get(T,'string'));
  if n>4 & POS>0
    POS=POS-1;
    for i=1:5,
      j=POS+i;
      set(INPUT(1,i),'string',num2str(j-1));
    end
    if RUN
      for i=1:5,
        j=POS+i;
        set(OUTPUT(1,i),'string',change('01',(EXPERIM_RES(j))));
	if is_Brown==1
	        set(OUTPUT(2,i),'string',change('01',(DELTA(j))));
	end;
      end      
    end
  end

elseif strcmp(action,'end')
  n=str2num(get(T,'string'));
  if n>4 & POS+4<n 
    POS=n-4;
    for i=1:5,
      j=POS+i;
      set(INPUT(1,i),'string',num2str(j-1));
    end

    if RUN
      for i=1:5,
        j=POS+i;
        set(OUTPUT(1,i),'string',change('01',(EXPERIM_RES(j))));
	if is_Brown==1
	        set(OUTPUT(2,i),'string',change('01',(DELTA(j))));
	end;
      end      
    end
  end;

elseif strcmp(action,'home')
  n=str2num(get(T,'string'));
  if n>4 & POS>0
    POS=0;
    for i=1:5,
      j=POS+i;
      set(INPUT(1,i),'string',num2str(j-1));
    end
    if RUN
      for i=1:5,
        j=POS+i;
        set(OUTPUT(1,i),'string',change('01',(EXPERIM_RES(j))));
	if is_Brown==1
	  set(OUTPUT(2,i),'string',change('01',(DELTA(j))));
	end;
      end      
    end
  end

elseif strcmp(action,'run')
  RUN=1;

  x=str2num(get(X,'string'));
  k=str2num(get(K,'string'));
  t=str2num(get(T,'string'));
  r=str2num(get(R,'string'))*.01;
  v=str2num(get(V,'string'))*.01;
  quantity=str2num(get(Q,'string'));
  perday=str2num(get(QDAY,'string'));
  type=get(MODEL(NUMBER(1)),'value');
  qw=get(QW,'string');
  is_Brown=type;

  if is_Brown~=1 
    is_Brown=0;
  end;
  
  % set quantile string
  for i=1:length(qw)	
    qww(i,:)=qw;	
  end;
  qw=str2num(qww);
  quanta=qw(1,:);		
  up=0;
  down=0;

  if (type==2)
    up=str2num(get(MODEL(5),'string'));
    down=str2num(get(MODEL(6),'string'));
  elseif type==4
    up=str2num(get(MODEL(3),'string'));
  elseif type==7|type==6
    up=(get(MODEL(4),'value'));
  end;
		
  skok=1/365;
  tau=skok/perday;
  tjot=[0:tau:t*skok];
  dlugosc=length(tjot);
  tt=(tau)^(1/2);
  sig=r-(v^2)/2;
  ttt=[0:1:t];

  if get(draw_quantiles,'value')==1
    xx = tt * randn (dlugosc, quantity);
    xx(1,:) = zeros (1, quantity);
    bjot = cumsum (xx);
    Y1 = (exp (sig * tjot' * ones (1, quantity) + v * bjot) * x)';

    ile=length(quanta);
    for i=1:ile
      qwant(i,:)=quantile(quanta(i),Y1);
    end;
				
    FIGURE=switch(FIGURE,2);
    set(FIGURE(2),'numbertitle','off','name','Quantile lines','visible','on');
    clf;hold on;
    plot(tjot*1/skok,qwant,'r');
	
    for i=1:ile
      napp(i,:)=num2str(quanta(i));
    end;
    text(ones(ile,1)*tjot(length(tjot))/skok,qwant(:,length(tjot)),napp);
	
    if type==1|type==6|type==5|type==2
      plot(ttt,k*ones(1,t+1));
      text(.5,k,'K');
    end;
    if type==2
      plot(ttt,up*ones(1,t+1));
      text(.5,up,'up');
      plot(ttt,down*ones(1,t+1));
      text(.5,down,'down');
    end;
    set(gca,'box','off');

    if NUMBER(1)==1
      payout('call',Y1,k,type,2,up,down);
    else
      payout('put',Y1,k,type,2,up,down);
    end;
    clear Y1;
    if perday~=1
      koniec=(length(tjot)-1)/perday;
      for i=1:koniec;
        EXPERIM_RES(:,i+1)=EXPERIM_RES(:,i*perday+1);
      end;
      EXPERIM_RES(:,koniec+2:t*perday+1)=[];
    end;

    EXPERIM_RES=EXPERIM_RES.*exp(-r*(0:t)*skok); % discounting
  else	% no quantiles
    xx = tt * randn (dlugosc, quantity);
    xx(1,:) = zeros (1, quantity);
    bjot = cumsum (xx);
    Y1 = (exp (sig * tjot' * ones (1, quantity) + v * bjot) * x)';

    if NUMBER(1)==1
      payout('call',Y1,k,type,2,up,down);
    else
      payout('put',Y1,k,type,2,up,down);
    end;
    clear Y1;
			
    if perday~=1
      koniec=(length(tjot)-1)/perday;
      for i=1:koniec;
        EXPERIM_RES(:,i+1) = EXPERIM_RES(:,i*perday+1);
      end;
      EXPERIM_RES(:,koniec+2:t*perday+1)=[];
    end;

    EXPERIM_RES=EXPERIM_RES.*exp(-r*(0:t)*skok);	
    set(FIGURE(2),'visible','off');
  end;
  if is_Brown==1
    [c,p]=bsvalue(x,k,[1:t],r*100,v*100);
    if NUMBER(1)==1
      cc=zeros(1,length(c)+1);
      cc(2:length(cc))=c;
      cc(1)=max(0,x-k);
      DELTA=cc;			
      clear p c cc;

  elseif NUMBER(1)==2
    cc=zeros(1,length(p)+1);
    cc(2:length(cc))=p;
    cc(1)=max(0,k-x);
    DELTA=cc;			
    clear p c cc;
  end;

  FIGURE=switch(FIGURE,3);
  set(FIGURE(3),'numbertitle','off','visible','on','name','BS & MC simulation');
  clf;					
  hold on;					
  plot(ttt,DELTA,':r');
  plot(ttt,EXPERIM_RES);
  set(gca,'box','off');
  set(BSVAL,'visible','on');
  for i=1:min(5,t),
    j=POS+i;
    set(OUTPUT(1,i),'string',change('01',(EXPERIM_RES(j))));
    set(OUTPUT(2,i),'visible','on','string',change('01',DELTA(j)));
  end;
  if POS+4<=t
    set(OUTPUT(1,5),'string',change('01',EXPERIM_RES(POS+5)));
    set(OUTPUT(2,5),'visible','on','string',change('01',(DELTA(POS+5))));
  else
    set(OUTPUT(:,5),'visible','on','string','');
  end;
  else
    set(BSVAL,'visible','off');
    FIGURE=switch(FIGURE,3);
    set(FIGURE(3),'numbertitle','off','visible','on','name','MC simulation');
    clf;					
    hold on;					
    plot(ttt,EXPERIM_RES);
    set(gca,'box','off');
    for i=1:min(5,t),
      j=POS+i;
      set(OUTPUT(1,i),'string',change('01',(EXPERIM_RES(j))));
      set(OUTPUT(2,i),'visible','off');
    end;
    if POS+4<=t
      set(OUTPUT(1,5),'string',change('01',EXPERIM_RES(POS+5)));
      set(OUTPUT(2,5),'visible','off');
    else
      set(OUTPUT(:,5),'visible','off');
    end;
  end;

elseif strcmp(action,'pop')
  hq=get(gco,'string');
  set(QW,'string',hq(get(gco,'value'),:));

elseif strcmp(action,'lambda')
  if number==1      
  co=get(gco,'string');
  co=str2num(co);
  if (isempty(co))
    co = -1;        
  end;
  if (co>=1|co<=0)
    set(MODEL(3),'string','.5');
  end;		
  elseif number==2
    rtv=get(QW,'string');
    rtv=change('02',rtv);
    artv=find(rtv<=0);
    brtv=find(rtv>=1);
    if (length(artv)~=0 |length(brtv)~=0)
      set(QW,'string','.3 .7');
    end;
  elseif number==3
    co1 = get(X,'string');
    co2 = get(K,'string');
    co1 = str2num(co1);
    co2 = str2num(co2);
    if (isempty(co1))
      co1 = -1;
    end;
    if (isempty(co2))
      co2 = -1;
    end;
    if (co1 < 0)
      set (X,'string','100');
    end;
    if (co2 < 0)
      set (K,'string','100');
    end;
  elseif number==4
    up=get(MODEL(5),'string');
    down=get(MODEL(6),'string');
    up=str2num(up);
    down=str2num(down);
    if (isempty(up) | isempty(down))
      up   = 0;	
      down = 1;	
    end;		
    if up<down
      set(MODEL(5),'string','110');
      set(MODEL(6),'string','90');
    end;	
  elseif number==5
    co=get(Q,'string');
    co = str2num(co);
    if (isempty(co))
      co = 0;
    end;
    if (fix(co)-co)~=0
      co = 0;
    end;
    if co < 2
      set(Q,'string','100');
    end;	
  elseif number==6
    co=get(QDAY,'string');	
    co = str2num(co);
    if (isempty(co))
      co = 0;
    end;
    if (fix(co)-co)~=0
      co = 0;
    end;
    if co < 1  
      set(QDAY,'string','12');
    end;
  elseif number==7
    co1=get(R,'string');	
    co2=get(V,'string');
    co1=str2num(co1);
    co2=str2num(co2);
    if (isempty(co1)) | (isempty(co2))
      co1 = -1;
      co2 = -1;
    end;
    if (co1 < 0) | (co2 < 0) 
      set(R,'string','3');
      set(V,'string','9');
    end;
  end;

elseif strcmp(action,'help')
  page1=...
    ['RUN                                                   '
     '  start simulations and calculate the option price;   '
     'HELP                                                  '
     '  this help window;                                   '
     'EXIT                                                  '
     '  return to FINDEMO;                                  '
     'TYPE                                                  '
     '  select call or put option;                          '
     'OPTIONS                                               '
     '  select plain vanilla, corridor knock-out, lookback  '
     '  (standard and modified) or asian (average rate,     '
     '  average strike, both arithmetic or geometric)       '
     '  option; for some options additional parameters have '
     '  to be specified;                                    '
     'PARAMETERS                                            '
     '  So - underlying instrument price at time 0;         '
     '  K - strike price;                                   '
     '  T - time to option maturity (in days);              '
     '  r,v - annual interest rate/volatility (in percent); '
     '  quantity - number of trajectories of the underlying '
     '    instrument (which are used to price the option);  '
     '  per day - number of simulation points per day;      '
     'OPTION PRICES                                         '
     '  Monte Carlo prices for the selected option with     '
     '  a given number of days to maturity; for plain       '
     '  vanilla options Black-Scholes prices are displayed  '
     '  below the simulated values; buttons: HOME, <, >     '
     '  and END can be used to change displayed maturities; '
     'QUANTILES                                             '
     '  turn on/off calculating and displaying quantile     '
     '  lines;                                              '];

  page2=...
    ['RUN                                                   '
     '  rozpoczecie symulacji (obliczen);                   '
     'HELP                                                  '
     '  pomoc;                                              '
     'EXIT                                                  '
     '  powrot do FINDEMO;                                  '
     'TYPE                                                  '
     '  typ opcji (opcja kupna lub sprzedazy);              '
     'OPTIONS                                               '
     '  wybor klasy opcji: waniliowa, korytarzowa typu      '
     '  knock-out, lookback (standardowa i zmodyfikowana)   '
     '  oraz azjatycka (average rate, average strike;       '
     '  arytmetyczna lub geometryczna); dla niektorych klas '
     '  opcji nalezy podac dodatkowe parametry;             '
     'PARAMETERS                                            '
     '  So - cena instrumentu podstawowego w chwili 0;      '
     '  K - cena wykonania opcji;                           '
     '  T - termin wygasniecia opcji (w dniach);            '
     '  r,v - roczna stopa procentowa/zmiennosc (w proc.);  '
     '  quantity - liczba symulacji, na podstawie ktorych   '
     '    jest wyceniana opcja;                             '
     '  per day - liczba punktow symulacji w ciagu dnia;    '
     'OPTION PRICES                                         '
     '  ceny Monte Carlo dla opcji o okreslonym czasie do   '
     '  terminu wygasniecia; dodatkowo dla opcji waniliowych'
     '  jest wyswietlana (dla porownania) cena Blacka-      '
     '  Scholesa; klawisze: HOME, <, > i END sluza do       '
     '  zmiany wyswietlanych terminow;                      '
     'QUANTILES                                             '
     '  wlaczenie/wylaczenie wyswietlania linii             '
     '  kwantylowych generowanego procesu ceny akcji;       '];

  buttonStr=['English';
             'Polski ';
             '       '];
  helpfn('Exotic options (Monte Carlo)',buttonStr,page1,page2);
  pos=get(gcf,'position');
  set(gcf,'name','Help',...
    'position',[pos(1) pos(2) 460 480],...
    'resize','off',...
    'menubar','none');

elseif strcmp(action,'exit')
  list=get(0,'children');
  for i=1:length(list),
    if list(i)~=FIGURE(5)
      close(list(i));
    end
  end
  set(FIGURE(5),'visible','on');
  clear global MODEL OPTION NUMBER RUN INPUT OUTPUT POS...
               TEXT X K T R V EXPERIM_RES DELTA...
               Q QW QDAY  BSVAL perday draw_quantiles is_Brown;
end

