function pos3(p,r,v,minp,maxp,nump,numt)
%POS3 Internally used by PART1.

% Copyright (c) 1996-98 by Rafal Weron.
% Written by: J. Glowinski, R. Weron.


nocontracts=p(:,1);
shortlong=p(:,2);
strike=p(:,3);
contract=p(:,4);
premium=p(:,5);
maturity=p(:,6);

if nargin<=5,
  nump=40;
  numt=10;
  if nargin<=3,
    minstrike=min(strike);
    maxstrike=max(strike);
    difstrike=maxstrike-minstrike;
    if difstrike==0, difstrike=round(1+maxstrike/100); end;
    minp=minstrike-difstrike;
    maxp=maxstrike+difstrike;
  end
end;

options=(contract~=0);
U=sort([linspace(minp,maxp,nump) strike(options)']);
nump=length(U);
if sum(options)>0
  maturity2=maturity(options);
  mint=min(maturity2);
  maxt=max(maturity2);
else
  mint=min(maturity);
  maxt=max(maturity);
end
time=linspace(0,mint,numt);
size1=size(p,1);
r=r/100;
v=v/100;

profitloss=zeros(numt,nump);
for i=1:numt,
  temp=zeros(1,nump);
  for j=1:size1,
    if maturity(j)>time(i)
      if contract(j)==0
        if shortlong(j)==1
          temp=temp+nocontracts(j)*(strike(j)-U);
        else
          temp=temp-nocontracts(j)*(strike(j)-U);
        end
      else
        K=strike(j);
        T=(maturity(j)-time(i))/365;
        e_rt=exp(-r.*T);
        vt=v.*sqrt(T);
        h=(log(U./K)./vt)+vt/2;
        if contract(j)==1
          X=U.*e_rt.*normcdf(h)-K.*e_rt.*normcdf(h-vt);
        else
          X=-U.*e_rt.*normcdf(-h)+K.*e_rt.*normcdf(vt-h);
        end
        if shortlong(j)==1
          temp=temp+nocontracts(j)*(premium(j)-X);
        else
          temp=temp-nocontracts(j)*(premium(j)-X);
        end
      end
    else
      if contract(j)==0
        if shortlong(j)==1
          temp=temp+nocontracts(j)*(strike(j)-U);
        else
          temp=temp-nocontracts(j)*(strike(j)-U);
        end
      elseif contract(j)==1
        if shortlong(j)==1
          temp=temp+nocontracts(j)*(premium(j)-max(0,U-strike(j)));
        else
          temp=temp-nocontracts(j)*(premium(j)-max(0,U-strike(j)));
        end
      else
        if shortlong(j)==1
          temp=temp+nocontracts(j)*(premium(j)-max(0,strike(j)-U));
        else
          temp=temp-nocontracts(j)*(premium(j)-max(0,strike(j)-U));
        end
      end
    end
  end
  profitloss(i,:)=temp;
end

mesh2(U,maxt-time,profitloss);
xlabel('Underlying');
ylabel('Maturity');
zlabel('Loss / Profit');
